org.apache.commons.collections4.multiset

## Class SynchronizedMultiSet<E>

- java.lang.Object
- - org.apache.commons.collections4.collection.SynchronizedCollection<E>
  - - org.apache.commons.collections4.multiset.SynchronizedMultiSet<E>

- Type Parameters:
    `E` - the type held in the multiset
  All Implemented Interfaces:
    Serializable, Iterable<E>, Collection<E>, MultiSet<E>

      public class SynchronizedMultiSet<E>
      extends SynchronizedCollection<E>
      implements MultiSet<E>

  Decorates another `MultiSet` to synchronize its behaviour for a multi-threaded environment.

  Methods are synchronized, then forwarded to the decorated multiset. Iterators must be separately synchronized around the loop.

  Since:
    4.1
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.commons.collections4.MultiSet

      `MultiSet.Entry<E>`

  - ### Field Summary

    - ### Fields inherited from class org.apache.commons.collections4.collection.SynchronizedCollection

      `lock`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SynchronizedMultiSet(MultiSet<E> multiset)` Constructor that wraps (not copies).
    `protected` | `SynchronizedMultiSet(MultiSet<E> multiset, Object lock)` Constructor that wraps (not copies).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `add(E object, int count)` Adds a number of occurrences of the specified object to the MultiSet.
    `protected MultiSet<E>` | `decorated()` Gets the multiset being decorated.
    `Set<MultiSet.Entry<E>>` | `entrySet()` Returns a `Set` of all entries contained in the MultiSet.
    `boolean` | `equals(Object object)` Compares this MultiSet to another object.
    `int` | `getCount(Object object)` Returns the number of occurrences of the given object currently in the MultiSet.
    `int` | `hashCode()` Gets a hash code for the MultiSet compatible with the definition of equals.
    `int` | `remove(Object object, int count)` Removes a number of occurrences of the specified object from the MultiSet.
    `int` | `setCount(E object, int count)` Sets the number of occurrences of the specified object in the MultiSet to the given count.
    `static <E> SynchronizedMultiSet<E>` | `synchronizedMultiSet(MultiSet<E> multiset)` Factory method to create a synchronized multiset.
    `Set<E>` | `uniqueSet()` Returns a `Set` of unique elements in the MultiSet.

    - ### Methods inherited from class org.apache.commons.collections4.collection.SynchronizedCollection

      `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, removeIf, retainAll, size, synchronizedCollection, toArray, toArray, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.collections4.MultiSet

      `add, containsAll, iterator, remove, removeAll, retainAll, size`

    - ### Methods inherited from interface java.util.Collection

      `addAll, clear, contains, isEmpty, parallelStream, removeIf, spliterator, stream, toArray, toArray`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

- - ### Constructor Detail

    - #### SynchronizedMultiSet

          protected SynchronizedMultiSet(MultiSet<E> multiset)

      Constructor that wraps (not copies).
      Parameters:
        `multiset` - the multiset to decorate, must not be null
      Throws:
        `NullPointerException` - if multiset is null

    - #### SynchronizedMultiSet

          protected SynchronizedMultiSet(MultiSet<E> multiset,
                                         Object lock)

      Constructor that wraps (not copies).
      Parameters:
        `multiset` - the multiset to decorate, must not be null
        `lock` - the lock to use, must not be null
      Throws:
        `NullPointerException` - if multiset or lock is null

  - ### Method Detail

    - #### synchronizedMultiSet

          public static <E> SynchronizedMultiSet<E> synchronizedMultiSet(MultiSet<E> multiset)

      Factory method to create a synchronized multiset.
      Type Parameters:
        `E` - the type of the elements in the multiset
      Parameters:
        `multiset` - the multiset to decorate, must not be null
      Returns:
        a new synchronized MultiSet
      Throws:
        `NullPointerException` - if multiset is null

    - #### decorated

          protected MultiSet<E> decorated()

      Gets the multiset being decorated.
      Overrides:
        `decorated` in class `SynchronizedCollection<E>`
      Returns:
        the decorated multiset

    - #### equals

          public boolean equals(Object object)

      Description copied from interface: `MultiSet`
      Compares this MultiSet to another object.

      This MultiSet equals another object if it is also a MultiSet that contains the same number of occurrences of the same elements.

      Specified by:
        `equals` in interface `Collection<E>`
      Specified by:
        `equals` in interface `MultiSet<E>`
      Overrides:
        `equals` in class `SynchronizedCollection<E>`
      Parameters:
        `object` - the object to compare to
      Returns:
        true if equal

    - #### hashCode

          public int hashCode()

      Description copied from interface: `MultiSet`
      Gets a hash code for the MultiSet compatible with the definition of equals. The hash code is defined as the sum total of a hash code for each element. The per element hash code is defined as `(e==null ? 0 : e.hashCode()) ^ noOccurances)`.
      Specified by:
        `hashCode` in interface `Collection<E>`
      Specified by:
        `hashCode` in interface `MultiSet<E>`
      Overrides:
        `hashCode` in class `SynchronizedCollection<E>`
      Returns:
        the hash code of the MultiSet

    - #### add

          public int add(E object,
                         int count)

      Description copied from interface: `MultiSet`
      Adds a number of occurrences of the specified object to the MultiSet.

      If the object is already in the `MultiSet.uniqueSet()` then increment its count as reported by `MultiSet.getCount(Object)`. Otherwise add it to the `MultiSet.uniqueSet()` and report its count as `occurrences`.

      Specified by:
        `add` in interface `MultiSet<E>`
      Parameters:
        `object` - the object to add
        `count` - the number of occurrences to add, may be zero, in which case no change is made to the multiset
      Returns:
        the number of occurrences of the object in the multiset before this operation; possibly zero

    - #### remove

          public int remove(Object object,
                            int count)

      Description copied from interface: `MultiSet`
      Removes a number of occurrences of the specified object from the MultiSet.

      If the number of occurrences to remove is greater than the actual number of occurrences in the multiset, the object will be removed from the multiset.

      Specified by:
        `remove` in interface `MultiSet<E>`
      Parameters:
        `object` - the object to remove
        `count` - the number of occurrences to remove, may be zero, in which case no change is made to the multiset
      Returns:
        the number of occurrences of the object in the multiset before the operation; possibly zero

    - #### getCount

          public int getCount(Object object)

      Description copied from interface: `MultiSet`
      Returns the number of occurrences of the given object currently in the MultiSet. If the object does not exist in the multiset, return 0.
      Specified by:
        `getCount` in interface `MultiSet<E>`
      Parameters:
        `object` - the object to search for
      Returns:
        the number of occurrences of the object, zero if not found

    - #### setCount

          public int setCount(E object,
                              int count)

      Description copied from interface: `MultiSet`
      Sets the number of occurrences of the specified object in the MultiSet to the given count.

      If the provided count is zero, the object will be removed from the `MultiSet.uniqueSet()`.

      Specified by:
        `setCount` in interface `MultiSet<E>`
      Parameters:
        `object` - the object to update
        `count` - the number of occurrences of the object
      Returns:
        the number of occurrences of the object before this operation, zero if the object was not contained in the multiset

    - #### uniqueSet

          public Set<E> uniqueSet()

      Description copied from interface: `MultiSet`
      Returns a `Set` of unique elements in the MultiSet.

      Uniqueness constraints are the same as those in `Set`.

      The returned set is backed by this multiset, so any change to either is immediately reflected in the other. Only removal operations are supported, in which case all occurrences of the element are removed from the backing multiset.

      Specified by:
        `uniqueSet` in interface `MultiSet<E>`
      Returns:
        the Set of unique MultiSet elements

    - #### entrySet

          public Set<MultiSet.Entry<E>> entrySet()

      Description copied from interface: `MultiSet`
      Returns a `Set` of all entries contained in the MultiSet.

      The returned set is backed by this multiset, so any change to either is immediately reflected in the other.

      Specified by:
        `entrySet` in interface `MultiSet<E>`
      Returns:
        the Set of MultiSet entries

Copyright © 2001–2019 The Apache Software Foundation. All rights reserved.